# PGP subroutines for Majordomo
#
# Uses PGP version 2.6.2.  Written for use with Majordomo 1.93
# by Patrick Hollins 10/95
# Under new ownership by John Perry 12/8/96 - perry@alpha.jpunix.com
# Send bugs, comments, suggestions to perry@alpha.jpunix.com
# You may do anything you like with the subroutines in this program.
# $Source: /home/majordom/RCS/PGPcode.pl,v $
# $Revision: 1.10 $
# $Date: 1995/10/31 15:10:27 $
#

# set your Majordomo secret key USER ID. Use the first format:
#	"'full user id <me@here>'" if more than 1 secret key on secring.pgp
# or the second format:
#	"oneword" if you have only 1 secret key on secring.pgp. (most common)
# use pgp -kv 'yourMjUserID' .pgp/secring.pgp to see your secring.pgp
#$PGP_sec_id="'majordomo\@jpunix.com>'";
$PGP_sec_id="Majordomo";

# set minimum secret key length a subscriber must have before
# joining a list on this server
$PGP_min_key_len=512;

# The following is used to determine which commands majordomo will process 
# as well as what commands a PGP protected list will process in the clear
$PGP_allowed_clear_text_commands='end which info lists help';

sub PGP_decrypt {
# decrypts a file.  called from resend

	local($filen,$list,$pp,@head,$head,$footer,$foot,$body);
	local($clear_text,$leader,$lead,@results,$new_head,$Sub);
	local($save_from,$save_to,$save_subject,$save_date);
	local($good_sig,@key_lines,$key_id,$user_id);

	$filen=shift(@_);
	$list=shift(@_);

	open(PGPMSG,$filen) || die " file not found $!\n";

	# save original header
	while (<PGPMSG>) {
		$head .= $_;
		last if /^\s*$/;
	}

	# parse clear text and cipher text sections
	$leader='y';
	while (<PGPMSG>) {
		if ( $leader && ! /BEGIN PGP MESSAGE/ ) {
			$lead .= $_;
		} else {
			$leader ='';
		}
		if ( ! $leader && ! $footer ) { $body .= $_ }
		if ( $footer ) { $foot .= $_ }
		if ( /END PGP MESSAGE/ ) { 
			if ( $footer ) {
				$body .= $foot;
				$foot = '';
			}
			$footer = 'y'
		}
	}
	$lead .= $foot;			# merge all clear text
	
	open(PGPBODY,">$tmp.cipher_body") || die " openning $tmp.cipher_body $!\n";
	print PGPBODY "$body";
	close(PGPBODY);

	chop($pp=`cat .pgp/.pp`);
	$clear_text=`PGPPASSFD=0;export PGPPASSFD;(echo \'$pp\';cat $tmp.cipher_body)|pgp +batchmode -ft 2>$tmp.pgp.results`;

	# cook up a vanilla header
	@head=split(/\n/,$head);
	while(@head) {
		$_=shift(@head);
		if (/^from:/i) { $save_from = $_ }
		if (/^to:/i) { $save_to = $_ }
		if (/^subject:/i) { $save_subject = $_ }
		if (/^date:/i) { $save_date = $_ }
	}
	($PGP_save_from) = $save_from =~ /^From:\s*(.+)/;	# used for bounces
	if ( ! $save_to ) { $save_to = "To: $opt_l\@$whereami" }
	if ( ! $save_subject ) { $save_subject="Subject: none" }
	($Sub) = $save_subject =~ /^Subject:[^0-9]*(\d+)/;
	if ( ! $Sub ) { $Sub = 'none' }
	$new_head = "From: owner-$list\@$whereami\nSubject: $Sub\n$save_to";

	# set the log now that I know who dunnit
	&set_log($log, $hostname, "majordomo", "$PGP_save_from");
	# massage PGP status results
	@results=`cat $tmp.pgp.results`;
	while (@results) {
		$_ = shift(@results);
		last if /^Current time/;
		last if /^\s+$/;
	}
	if ( $#results == -1 ) {
		&log("sent a clear text submission");
		$results[0]="WARNING !!! THIS WAS SUBMITTED IN CLEAR TEXT !!!\n";
		}
	while (@results) {
		$_=shift(@results);
		next if /^File is encrypted/;
		next if /^Pass phrase is good/;
		next if /^Also known as:/;
		next if /^File has signature/;
		next if /^\s+$/;
		if ( /^Good signature from user/ ) { $good_sig = $_ }
		$results .= "$_";
	}
	$good_sig =~ /^Good signature from user "([^"]+).*/;
	if ( $1 ) {
		$PGP_user_id = "'$1'";
		@key_lines=`pgp -kv +batchmode $PGP_user_id | grep $PGP_user_id`;
		while (@key_lines) {
			$_=shift(@key_lines);
			m,^pub\s+\d+/(\w+)\s+\d{4}/\d{2}/\d{2}\s+(.+)$,;
			$key_id=$1 ; $user_id="'$2'";
			last if ($user_id eq $PGP_user_id);
		}
		if ($user_id eq $PGP_user_id) { $PGP_key_id = '(0x' . $key_id . ')' }
	} else {
		&log("Encrypted, but unsigned submission");
	}
	
	# write the formatted message
	open(PGPCLEAR,">$tmp.ro9") || die "died opening pgp output $!\n";
	print PGPCLEAR "$new_head\n\n\n";
	print PGPCLEAR "$save_from\n$save_date\n";
	if ( $lead =~ /\S+/ ) {
		print PGPCLEAR "############# Clear Text received $save_from #############\n";
		print PGPCLEAR "$lead";
		print PGPCLEAR "################################################################\n\n";
	}
	print PGPCLEAR "###################### Encrypted Message #######################\n";
	print PGPCLEAR "$clear_text";
	print PGPCLEAR "################################################################\n\n";
	print PGPCLEAR "################# Submission Decryption status #################\n";
	print PGPCLEAR "$results";
	print PGPCLEAR "################################################################\n\n";
	print PGPCLEAR "########## Clear Text header as received by Majordomo ##########\n";
	print PGPCLEAR "$head";
	print PGPCLEAR "################################################################\n";
	close(PGPCLEAR);

	system("cp $tmp.ro9 $filen");
	unlink($tmp.ro9);
	return;
}

sub PGP_encrypt {
	# encrypts a file for all list subscribers or to owner-listname in 
	# case of bounces
	local($filen,$To,$pp,$cipher_text,@few,$name,$keyid,$list,$head,@file);
	$filen=shift(@_);
	$list=shift(@_);
	
	# extract header and rewrite
	@file=`cat $filen`;
	while(@file) {
		$_=shift(@file);
		last if /^\s+$/;
		$head .= $_;
	}
	open(PGPOUT,">$filen") || die "died rewriting file less header $! \n";
	print PGPOUT @file;
	close(PGPOUT);
	
	# get PGP key IDs of receiptients
	if (-f "$listdir/$list") {
		# all subscribers of the list
		$To=`awk '{print \$2}' $listdir/$list`;
	} else {
		# just the owner-listname members
		@few=grep(/\b$list\b/,`cat $listdir/$opt_l`);
		while (@few) {
			$_=shift(@few);
			($name,$keyid)=split(' ',$_);
			$To .= $keyid . ' ';
		}
	}

	$To=~ s/\(|\)|\n/ /g;
	if ( ! $To ) {
		&log("$opt_l: no receipients for file encryption. aborting. See and delete $tmp files.");
		&PGP_tell_admin("$opt_l: no receipients for file encryption. aborting. See and delete $tmp files.");
		exit 1;
	}
	chop($pp=`cat .pgp/.pp`);
	$cipher_text=`PGPPASSFD=0;export PGPPASSFD;(echo \'$pp\';cat $filen)|pgp +batchmode -feast $To -u $PGP_sec_id`;
	
	open(PGPOUT,">$filen") || die " rewriting $filen $!\n";
	print PGPOUT "$head\n";
	print PGPOUT $cipher_text;
	close(PGPOUT);
	return;
}

# slurp STDIN, massage and reopen filtered data as STDIN
# called from majordomo
sub PGP_decrypt_request {
	local(@req,@pgp_stat,$key_id,$user_id);
	local(@key_lines,$pp,$good_sig);
	open(PGPOUT,">$tmp.pgp") || die "stopped opening PGPOUT $!\n";
	@req=(<>);
	if ( grep(/^\s*\bsubscribe\b/i,@req) && ! grep(/\bapprove\b/i,@req) ) {
		# subscription request
		print PGPOUT @req;
		# smash any previous output as reply is in the clear
		close(REPLY);
		&PGP_open_request(REPLY);
		$PGP_reply_in_clear='y';
		close(PGPOUT);
		open(STDIN,"$tmp.pgp") || die "re-opening $tmp.pgp as STDIN $!\n";
	} else {
		# decrypt and process
		$PGP_reply_in_clear='';
		print PGPOUT @req;
		close(PGPOUT);
		chop($pp=`cat .pgp/.pp`);
		@pgp_stat=`PGPPASSFD=0;export PGPPASSFD;echo \'$pp\'|pgp +batchmode -t $tmp.pgp -o $tmp.pgpO`;
		if ( open(PGPOUT,"$tmp.pgpO") ) { 
			@req=<PGPOUT>;
			close(PGPOUT);
			if ( grep(/is not a ciphertext/,@pgp_stat) ) {
				# report commands as errors
				if ($opt_e) {&log("Clear text request from $reply_to :" . `cat $tmp.pgp`) }
				$PGP_encrypted = '';
				open(STDIN,"$tmp.pgp") || die "re-opening $tmp.pgp as STDIN $!\n";
			} else {
				$PGP_encrypted = 'y';
				open(STDIN,"$tmp.pgpO") || die "re-opening $tmp.pgpO as STDIN $!\n";
			}
		} else {
			$PGP_encrypted = ''; $PGP_reply_in_clear = 'y';
			open(STDIN,"$tmp.pgp") || die "re-opening $tmp.pgp as STDIN $!\n";
		}
	}
	# get senders PGP User and Key ID - requires signature!!
	# sets global variable PGP_user_id as: 'primary user id <them@there>'
	# sets global variable PGP_key_id as: (0x12345678)
	if ($PGP_encrypted) {
		($good_sig)=grep(/^Good signature from user/,@pgp_stat);
		$good_sig =~ /^Good signature from user "([^"]+).*/;
		if ( $1 ) {
			$PGP_user_id = "'$1'";
			@key_lines=`pgp -kv +batchmode $PGP_user_id | grep $PGP_user_id`;
			while (@key_lines) {
				$_=shift(@key_lines);
				m,^pub\s+\d+/(\w+)\s+\d{4}/\d{2}/\d{2}\s+(.+)$,;
				$key_id=$1 ; $user_id="'$2'";
				last if ($user_id eq $PGP_user_id);
			}
			if ($user_id eq $PGP_user_id) { $PGP_key_id = '(0x' . $key_id . ')' }
		} else {
			&log("unsigned request from $reply_to:\n@pgp_stat\n trying:\n@req");
		}
	}
}

sub PGP_slurp_subscribe_request {
	local($grab);
	$PGP_newsub_info='';
	$PGP_no_pub_key='y';
	while ( <> ) {
		s/^\s+//;	# remove extra space generated by encry-decry of Pub Key
		$PGP_newsub_info .= $_;
		if ( /BEGIN PGP PUBLIC KEY BLOCK/ ) { $grab = 'y' }
		if ($grab) { $PGP_public_key .= $_ }
		if ( /END PGP PUBLIC KEY BLOCK/ ) {
			if ( $PGP_public_key ) { $PGP_no_pub_key = '' }
			$grab='n';
		}
	}  
}

sub PGP_open_request {
	local($PGP_reply_fh)=shift(@_);
	open($PGP_reply_fh,">$tmp.$PGP_reply_fh") || die "opening $tmp.$PGP_reply_fh $!\n";
	select((select($PGP_reply_fh), $| = 1)[0]);
	return;
}

sub PGP_close_request {
	local($PGP_reply_fh)=shift(@_);
	local($this_to,$cipher_text,$pp);
	close($PGP_reply_fh);
	if ($PGP_reply_in_clear ) {
		&sendmail(PGPREPLY,$reply_to,"Majordomo results$sub_addin");
		select((select(PGPREPLY), $| = 1)[0]);
		print PGPREPLY `cat $tmp.$PGP_reply_fh`;
		close(PGPREPLY);
		return;
	}

	if ($PGP_key_id) {
		($this_to = $PGP_key_id) =~ s/\(|\)//g;
	} elsif ($PGP_user_id) {
		$this_to = $PGP_user_id;
	} else {
		($this_to = $reply_to) =~ /(\S+)[^@]/;
	}
	chop($pp=`cat .pgp/.pp`);
	$cipher_text=`PGPPASSFD=0;export PGPPASSFD;(echo \'$pp\';cat $tmp.$PGP_reply_fh)|pgp -feast $this_to -u $PGP_sec_id`;
	
	&sendmail(PGPREPLY,$reply_to,"Majordomo results$sub_addin");
	select((select(PGPREPLY), $| = 1)[0]);
	if ($cipher_text) {
		print PGPREPLY "$cipher_text\n";
	} else {
		print PGPREPLY "I cannot find your public key.\n";
		print PGPREPLY "Results from this request must be encrypted and are being forwarded to\n";
		print PGPREPLY "the system administrator.  Contact $whoami_owner for assistance.\n";
		&log("could not encrypt results for $this_to");
		&PGP_tell_admin("could not encrypt the following results for $this_to :\n" . `cat $tmp.$PGP_reply_fh`);
	}
	close(PGPREPLY);
}

sub PGP_add_public_key {
	local($public_key)=shift(@_);
	open(PUBKEY,">$tmp.pubkey") || die "writing $tmp.pubkey $!\n";
	print PUBKEY "$public_key\n";
	close(PUBKEY);
	`pgp +batchmode -ka $tmp.pubkey`;
}

sub PGP_test_public_key {
	local($public_key)=shift(@_);
	local(@add_out,$key_len,$num_keys,$update_ok,$pp);
	open(PUBKEY,">$tmp.pubkey") || die "writing $tmp.pubkey $!\n";
	print PUBKEY "$public_key\n";
	close(PUBKEY);
	chop($pp=`cat .pgp/.pp`);
	@add_out=`PGPPASSFD=0;export PGPPASSFD;echo \'$pp\'|pgp +batchmode -ka $tmp.pubkey $tmp.pubring.pgp`;
	unlink($tmp.pubring.pgp);

	$key_len=0; $PGP_key_id_new =''; $num_keys=0;
	while (@add_out) { 
		$_=shift(@add_out);
		if ( /^pub\s+(\d+)\/([A-F0-9]+) /i ) {
			$key_len=$1; $PGP_key_id_new=$2; $num_keys++;
		}
		if ( /Updated keyID:\s+0x([A-F0-9]+)/i ) {
			if ( $1 ne $PGP_key_id_new ) { return "invalid public key" }
			$update_ok='y';
		}
		last if /Checking signatures/i;
	}
	if ( $num_keys != 1 || ! $update_ok ) { 
		&log("$subscriber had $num_keys public keys when trying to join $list");
		return "$num_keys keys found in PGP Public Key block";
	}
	if ( $key_len < $PGP_min_key_len ) {
		&log("$subscriber had a key length of $key_len trying to join $list");
		return "PGP Key length of $key_len is shorter than the required $PGP_min_key_len bits.";
	}
	$PGP_key_id_new='(0x' . $PGP_key_id_new . ')';
	if ( ! $PGP_key_id && ! $PGP_user_id ) { $PGP_key_id = $PGP_key_id_new }
}

sub PGP_remove_public_key {
	local($who)=shift;
	local($list)=shift;
	local($key_id,@lists,@sch_lists,$list_cnt);

	opendir(PGP_RD_DIR,"$listdir") || &abort("opendir failed $!");
	@lists = readdir(PGP_RD_DIR);
	closedir(PGP_RD_DIR);
	foreach (@lists) {
		/[^-_0-9a-zA-Z]/ && next;   # skip non-list files (*.info, etc.)
		push(@sch_lists,"$listdir/$_");
	}

	if (! $approved) {	# self describe - use PGP_key_id
		$key_id = $PGP_key_id;
		if ( ! $key_id ) { $key_id = $PGP_user_id}
	}
	if ( ! $key_id ) {  # check for keyid on approved unsub or other
		($key_id) = $who =~ /(\(0x\d+\))\s*/;
	}
	if ( ! $key_id ) {  # stuck with just a subscribers address :-(
		&PGP_tell_admin("Tell perry\@alpha.jpunix.com to improve sub PGP_remove_public_key.  Meanwhile, manually delete the public key for $who if they are not on any PGP lists.");
		return;
	}

	$list_cnt=`awk '{print $2}' @sch_lists | grep '$key_id' | wc -l`;
	
	if ( $list_cnt != 1 ) { return }	# on more than 1 list

	$key_id =~ s/\(|\)//g;

	# can't remove right now! wait until after pgp reply is sent
	$PGP_exec_rm_key_later.="pgp +batchmode +force -kr $key_id;";
	&log("removed PGP key ID $key_id");
}

sub PGP_tell_admin {
	# This is also a *very* useful routine for debugging. hint hint.
	local($msg)=@_;
	&sendmail(PGPFINK,$whoami_owner,"Majordomo PGP notification");
	print PGPFINK "$msg\n";
	close(PGPFINK);
}
1;
